/*
 * The associated code, schematics & pcb are completely free for you to use.
 * There is NO warranty whatever, implied or otherwise.
 */
#include "demo.h"

_FGS(GSS_OFF & GCP_OFF & GWRP_OFF);
_FOSCSEL( IESO_OFF &  FNOSC_FRCPLL);
_FOSC(FCKSM_CSDCMD & IOL1WAY_OFF & OSCIOFNC_ON & POSCMD_NONE);
_FWDT(FWDTEN_OFF & WINDIS_OFF & WDTPRE_PR128 & WDTPOST_PS32768);
_FPOR(ALTI2C_OFF & FPWRT_PWR128);
_FICD(JTAGEN_OFF & ICS_PGD1);

/*
 * Main
 */
int main(void)
{
    int
	delta, pwm, n;
    char
	buf[256];
    
    AD1PCFGL = 0xFFF0;				// DDDD_DDDD_DDDD_AAAA

    TRISA = 0x0203;				// OOOO_OOIO_OOOO_OOAA
    TRISB = 0x0C1F;				// OOOO_IIOO_OOOI_IIAA
    TRISC = 0x03E4;				// OOOO_OOII_IIIO_OIOO

    CNPU1 = 0x01F0;				// 

    /*
     * Setup clock to run at 40MHz using internal 7.37MHz oscillator
     *
     * Configure PLL prescaller, postscaller, & divisor
     */
    PLLFBD = 43-2;				// M = 41
    CLKDIVbits.PLLPOST = 0;			// N2 = 2
    CLKDIVbits.PLLPRE = 0;			// N1 = 2
    /*
     * Unlock the clock. Switch to PRI with PLL
     */
    __builtin_write_OSCCONH(3);
    __builtin_write_OSCCONL(OSCCON | 0x01);
    
    /*
     * Wait for clock switch to occur
     */
    while (OSCCONbits.COSC != 1) Nop();
     /*
     * Wait for clock lock to occur
     */
    while (OSCCONbits.LOCK != 1) Nop();

    tmrInit();
    uartInit();
    pwmInit();
    qeiInit();

    /*
     * Pause to let the pic programmer perform resets associated with loading
     * new code into the chip. reemove if it bothers you
     */
    pause(1500);

    printf("\n\nDC motor drive demo\n");

    while (1)
    {
	pwmSet(0);				// set speed to 0
	printf("Hit any key to start: ");
	uartGetc();
    
	pwm  = 0;
	delta = 250;
	while (uartCharAvail() == 0)
	{
	    if ((pwm >=  2000) || (pwm <= -2000))
	    {
		pause(2000);
		delta = -delta;
	    }

	    pwm += delta;
	    pwmSet(pwm);
	    pause(1000);
	    printf("%5d, %5d\n", pwm, qeiCnt);
	}
	uartGetc();
    }

    return(0);
}
