/*
 * The associated code, schematics & pcb are completely free for you to use.
 * There is NO warranty whatever, implied or otherwise.
 */
#include "demo.h"

int	dir;

/*
 * Setup Output Compare 3 module to generate a pwm pulse train.
 * The h-bridge has 2 inputs. One goes to the pwm output and
 * other is held high or low to determine direction.
 *
 * Port B 12 - RM_FIN
 *        13 - RM_RIN
 */
void pwmInit(void)
{
    dir = STOP;

    TMR3 = 0;					// set the current value
    PR3 = 50 * 40;				// trigger every 50 usec
    

    LATBbits.LATB12 = 0;			// right motor - both low
    LATBbits.LATB13 = 0;
    
    TRISBbits.TRISB12 = 0;
    TRISBbits.TRISB13 = 0;

    OC3CONbits.OCM = 0;				// disable Output Compare Module
    OC3R = 0;					// write the duty cycle for the first PWM pulse
    OC3RS = 0;					// write the duty cycle for the second PWM pulse
    OC3CONbits.OCTSEL = 1;			// select Timer 3 as output compare time base
    OC3CONbits.OCM = 6;				// select the PWM output mode
//    OC3R = 0;					// load the Compare Register Value
//    OC3RS = 0;				// write the duty cycle for the second PWM pulse
    T3CONbits.TON = 1;
}

/*
 *
 */
void pwmSet(int newVal)
{
    if (newVal >= 0)
    {
	if (dir != FWD)
	{
	    dir = FWD;
	    _RP12R = RPO_OC3;
	    _RP13R = 0;
	}
	OC3RS = newVal;				// write the duty cycle for the second PWM pulse

    }
    else
    {
	if (dir != REV)
	{
	    dir = REV;
	    _RP12R = 0;
	    _RP13R = RPO_OC3;
	}
	OC3RS = -newVal;			// write the duty cycle for the second PWM pulse
    }
}    
