/*
 * The associated code, schematics & pcb are completely free for you to use.
 * There is NO warranty whatever, implied or otherwise.
 */
#include "demo.h"

int	  ledTic, qeiTic, qeiCnt;
uint32_t  runTime;

/*
 * Delay the specified number of milliseconds.
 */
void pause(uint16_t n)
{
    uint32_t
	nextTime;

    nextTime = runTime + n;
    while (runTime < nextTime) Nop();
}


/*
 * 1 msec for delays and reading the qei
 */
void tmrInit(void)
{
    runTime = 0;
    qeiCnt = 0;
    qeiTic = 0;
    ledTic = 0;
    
    T1CON = 0;
    T1CONbits.TCKPS = 1;			// divide by 8 prescaler
    TMR1 = 0;
    PR1 = (1000U / 8U) * 40U;			// 1 msec

    IPC0bits.T1IP = 1;				// set timer 1 interrupt priority level
    IFS0bits.T1IF = 0;				// clear timer 1 interrupt flag
    IEC0bits.T1IE = 1;				// enable timer 1 interrupts

    T1CONbits.TON = 1;				// enable the timer
}
/*
 * Timer 1 ISR
 */
void __attribute__((__interrupt__, no_auto_psv)) _T1Interrupt(void)
{
    qeiTic++;
    if (qeiTic == 100)
    {
	qeiCnt = POS2CNT;
	POS2CNT = 0;
	qeiTic = 0;
    }
    ledTic++;
    if (ledTic == 200)
    {
	LATAbits.LATA2 ^= 1;
	ledTic = 0;
    }
    runTime++;
    IFS0bits.T1IF = 0;				// clear Timer 1 interrupt flag
}
